package GUI;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.LinkedList;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JTextField;

import MainPackage.*;

public class ResourceEditWindow extends JFrame {
	Project thisproj = MainClass.getInstance();
	LinkedList<Resource> resourcelist;
	LinkedList<Job> jobslist;

	public ResourceEditWindow(final Resource r) {
		super("Add new job");
		final JFrame jf = this;
		setSize(400, 200);
		setResizable(true);
//		setMaximumSize(new Dimension(500, 400));
		setMinimumSize(new Dimension(400, 200));
		setDefaultCloseOperation(HIDE_ON_CLOSE);
		final JLabel jobname = new JLabel("Resource's title:");
		JLabel selectprev = new JLabel("Current jobs:");
		final JList<Object> jlistb;
		jobslist = thisproj.getAllUnusedJobs();

		if (!thisproj.getAllJobs().isEmpty()) {
			LinkedList<Job> jobslist = r.getJobs();
			LinkedList<Job> alljobslist = thisproj.getAllUnusedJobs();
			LinkedList<Job> jobslistmerge = new LinkedList<Job>();
			jobslistmerge.addAll(jobslist);
			jobslistmerge.addAll(alljobslist);

			Object[] jobsarray = jobslist.toArray();
			Object[] alljobsarray = jobslistmerge.toArray();

			jlistb = new JList<Object>(alljobsarray);
			LinkedList<Integer> selind = new LinkedList<Integer>();// selected indices
			for (Object j : jobsarray) {
				if (jobslistmerge.indexOf(j) != -1)
					selind.add(jobslistmerge.indexOf(j));
			}
			int[] sel = new int[selind.size()];
			for (int i = 0; i < selind.size(); i++) {
				sel[i] = selind.get(i);
			}

			jlistb.setSelectedIndices(sel);
		} else {
			jlistb = new JList<Object>();
		}
		jlistb.setLayoutOrientation(JList.HORIZONTAL_WRAP);
		final JTextField jtf = new JTextField(r.toString());
		JPanel choisepan = new JPanel();
		BoxLayout bl = new BoxLayout(choisepan, BoxLayout.Y_AXIS);
		choisepan.setLayout(bl);
		choisepan.add(jobname);
		choisepan.add(jtf);
		choisepan.add(selectprev);
		choisepan.add(jlistb);
		JButton butOk = new JButton("Add");
		butOk.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (!jobslist.isEmpty()) {
					if (jtf.getText() != r.toString()) {
						r.setName(jtf.getText());
					}
					thisproj.removeAllJobFromResource(r);
					for (Object j : jlistb.getSelectedValuesList())
						r.addJob((Job) j);
				}
				thisproj.valueChanged();
				jf.dispose();
			}
		});
		JButton butCan = new JButton("Cancel");
		butCan.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {
				jf.dispose();

			}
		});
		getContentPane().add(choisepan, "North");
		JPanel butpan = new JPanel();
		bl = new BoxLayout(butpan, BoxLayout.X_AXIS);
		butpan.setLayout(bl);
		butpan.add(butOk, "South");
		butpan.add(Box.createHorizontalStrut(10));
		butpan.add(butCan, "South");
		butpan.add(Box.createHorizontalStrut(10));
		getContentPane().add(butpan, "East");
		setVisible(true);

	}
}
